package com.jiuqi.util;

package .tmp;

import com.jiuqi.util.JqLib;
import com.jiuqi.util.SortItem;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

public class SortList {
  private Stack cacheItems = new Stack();
  
  private List sortItems = new ArrayList();
  
  public void reset() {
    this.cacheItems.addAll(this.sortItems);
    this.sortItems.clear();
  }
  
  public void addItem(Object key, int identy) {
    SortItem si = null;
    if (this.cacheItems.empty()) {
      si = new SortItem(key, identy);
    } else {
      si = this.cacheItems.pop();
      si.key = key;
      si.identy = identy;
    } 
    this.sortItems.add(si);
  }
  
  public void addItem(Object key, Object value) {
    SortItem si = null;
    if (this.cacheItems.empty()) {
      si = new SortItem(key, value);
    } else {
      si = this.cacheItems.pop();
      si.key = key;
      si.value = value;
    } 
    this.sortItems.add(si);
  }
  
  public void sort(boolean desc) {
    JqLib.listSort(this.sortItems);
    if (desc)
      JqLib.listRevert(this.sortItems); 
  }
  
  public int size() {
    return this.sortItems.size();
  }
  
  public Object getKey(int index) {
    return ((SortItem)this.sortItems.get(index)).key;
  }
  
  public int getIdenty(int index) {
    return ((SortItem)this.sortItems.get(index)).identy;
  }
  
  public Object getValue(int index) {
    return ((SortItem)this.sortItems.get(index)).value;
  }
  
  public int findAsc(Object key) {
    SortItem si = null;
    synchronized (this.cacheItems) {
      if (!this.cacheItems.empty()) {
        si = this.cacheItems.pop();
        si.key = key;
        si.identy = 0;
      } 
    } 
    if (si == null)
      si = new SortItem(key, 0); 
    int result = JqLib.listFind(this.sortItems, (Comparable)si);
    this.cacheItems.add(si);
    return result;
  }
  
  public int indexOfIdenty(int identy) {
    for (int i = 0; i < this.sortItems.size(); i++) {
      SortItem si = this.sortItems.get(i);
      if (si.identy == identy)
        return i; 
    } 
    return -1;
  }
  
  public int indexOfValue(Object value) {
    for (int i = 0; i < this.sortItems.size(); i++) {
      SortItem si = this.sortItems.get(i);
      if (si.value == value || (value != null && value.equals(si.value)))
        return i; 
    } 
    return -1;
  }
}
